题干:
This is a simple problem. The teacher gives Bob a list of problems about GCD (Greatest Common Divisor). After studying some of them, Bob thinks that GCD is so interesting. One day, he comes up with a new problem about GCD. Easy as it looks, Bob cannot figure it out himself. Now he turns to you for help, and here is the problem:
Given an array aa of NN positive integers a1,a2,⋯aN−1,aNa1,a2,⋯aN−1,aN; a subarray of aa is defined as a continuous interval between a1a1 and aNaN. In other words, ai,ai+1,⋯,aj−1,ajai,ai+1,⋯,aj−1,aj is a subarray of aa, for 1≤i≤j≤N1≤i≤j≤N. For a query in the form (L,R)(L,R), tell the number of different GCDs contributed by all subarrays of the interval [L,R][L,R].
Input
There are several tests, process till the end of input.
For each test, the first line consists of two integers NN and QQ, denoting the length of the array and the number of queries, respectively. NN positive integers are listed in the second line, followed by QQ lines each containing two integers L,RL,R for a query.
You can assume that
1≤N,Q≤1000001≤N,Q≤100000
1≤ai≤10000001≤ai≤1000000
Output
For each query, output the answer in one line.
Sample Input
5 3
1 3 4 6 9
3 5
2 5
1 5
Sample Output
6
6
6
题目大意:
给定一个长度n的序列, m个询问区间[L, R], 问区间内的所有子区间的不同GCD值有多少种.
解题报告:
首先一个套路结论就是gcd值下降非常快,最多log次就降为1,所以以每个数为右端点,往前扫的左端点的gcd肯定不会很多,所以直接暴力维护每个点为右端点,的所有gcd值的出现的最右位置(因为随着左端点的左移,gcd是单调不增的,所以只需要记录每个gcd出现的最右位置)。然后直接做区间查询不同数的个数就可以了。在线可以主席树,离线可以树状数组。
当然这题也可以不这样预处理,而是用类似RMQ的方法直接处理区间gcd,然后每次二分的往前找这个位置就可以了。
AC代码:
#include<cstdio>
#include<iostream>
#include<algorithm>
#include<queue>
#include<stack>
#include<map>
#include<vector>
#include<set>
#include<string>
#include<cmath>
#include<cstring>
#define FF first
#define SS second
#define ll long long
#define pb push_back
#define pm make_pair
using namespace std;
typedef pair<int,int> PII;
const int MAX = 1e6 + 5;
int n,q;
struct Node {int l,r,id;
} Q[100005];
bool cmp(Node a,Node b) {return a.r < b.r;
}
vector<PII> vv[MAX];//gcd值和对应的位置
int a[MAX];
int pos[MAX];
int ans[MAX];
int c[MAX];
void update(int x,int val) {while(x < MAX) {c[x] += val;x += x&-x;}
}
int sum(int x) {int res = 0;while(x>0) {res += c[x];x -= x&-x;}return res;
}
int main()
{while(cin>>n>>q) {for(int i = 1; i<=n; i++) scanf("%d",a+i),vv[i].clear();memset(pos,0,sizeof pos);memset(c,0,sizeof c);for(int i = 1; i<=n; i++) {int up = vv[i-1].size(),tmp = a[i],now=a[i];vv[i].pb(pm(a[i],i));for(int j = 0; j<up; j++) {now = __gcd(now,vv[i-1][j].FF);if(now == tmp) continue;tmp = now;vv[i].pb(pm(now,vv[i-1][j].SS));}} for(int i = 1; i<=q; i++) scanf("%d%d",&Q[i].l,&Q[i].r),Q[i].id = i;sort(Q+1,Q+q+1,cmp);int cur=1;for(int i = 1; i<=q; i++) {while(cur <= Q[i].r) {int up = vv[cur].size();for(int j = 0; j<up; j++) {if(pos[vv[cur][j].FF]) update(pos[vv[cur][j].FF],-1);update(vv[cur][j].SS,1);pos[vv[cur][j].FF] = vv[cur][j].SS;} cur++;}ans[Q[i].id] = sum(Q[i].r) - sum(Q[i].l - 1);}for(int i = 1; i<=q; i++) printf("%d\n",ans[i]); }return 0 ;
}
贴一个题解:
感觉很像线段树/树状数组. 因为有很多题都是枚举从小到大处理查询的r. 这样的话就只需要维护[1,i]的情况最开始用的set记录生成的gcd然后递推, 超时了.
因为区间gcd是有单调性的. (i-1->1)和i区间gcd是递减的.
而且用RMQ可以O(1)的查询[i,j]gcd的值.如果枚举[1,i-1]感觉很麻烦.所以用二分跳过中间gcd值相同的部分,即查询与i的区间gcd值为x的最左边端点.
因为要求不同的值, 这让我想到了用线段树求[l,r]中不同数的个数(忘了是哪道题了 zz)
就i而言,首先找出最靠近i的位置使gcd的值为x. 然后和以前的位置作比较. 尽可能的维护这个位置靠右.